import { world,MolangVariableMap,system } from "@minecraft/server"
import * as particleIdentifier from "./rdl"
//spawnParticle在1.20.30（最早于server@1.4.0-beta加入）
function parseToMolang(ms) {
    var molang = new MolangVariableMap()
    molang.setFloat("variable.sx",0.1);
    molang.setFloat("variable.sy",0.1);
    molang.setFloat("variable.lifelong",2)
    molang.setColorRGBA("variable.color",{red:1,green:1,blue:1,alpha:1})
    for (const key in ms) {
        if(key=="size") {
            molang.setFloat("variable.sx",ms[key][0])
            molang.setFloat("variable.sy",ms[key][1])
        }
        else if(key=="lifelong") {
            molang.setFloat("variable.lifelong",ms[key])
        }
        else if(key=="color") {
            var colorArr = [1,1,1,1]
            for(let i=0;i<ms[key].length;i++) colorArr[i]=ms[key][i]
            molang.setColorRGBA("variable.color",{red:colorArr[0],
                                                  green:colorArr[1],
                                                  blue:colorArr[2],
                                                  alpha:colorArr[3]})
        }
    }
    return molang
}
system.afterEvents.scriptEventReceive.subscribe((e) => {
    if(e.id.substring(0,11)=="zp:particle") {
        const jms=JSON.parse(e.message)
        var particleType = particleIdentifier.ROTATE_XYZ
        if(e.id.substring(12)=="rxyz") particleType = particleIdentifier.ROTATE_XYZ
        else if(e.id.substring(12)=="lxyz") particleType = particleIdentifier.LOOKAT_XYZ
        else if(e.id.substring(12)=="ly") particleType = particleIdentifier.LOOKAT_Y
        else if(e.id.substring(12)=="ry") particleType = particleIdentifier.ROTATE_Y
        else if(e.id.substring(12)=="txy") particleType = particleIdentifier.TRANSFORM_XY
        else if(e.id.substring(12)=="txz") particleType = particleIdentifier.TRANSFORM_XZ
        else if(e.id.substring(12)=="tyz") particleType = particleIdentifier.TRANSFORM_YZ
        if(e?.sourceEntity!=undefined)
            e?.sourceEntity.dimension.spawnParticle(particleType,
                                                    e?.sourceEntity.location,
                                                    parseToMolang(jms))
        else
            e?.sourceBlock.dimension.spawnParticle(particleType,
                                                   e?.sourceBlock.location,
                                                   parseToMolang(jms))
    }
})